<?php
namespace Ep\Search;

use Interop\Container\ContainerInterface;
use Solarium\Client as SolariumClient;
use Laminas\ServiceManager\Factory\FactoryInterface;
use Solarium\Core\Client\Adapter\Curl;
use Symfony\Component\EventDispatcher\EventDispatcher;
use Symfony\Contracts\EventDispatcher\Event;

/**
 * Class ClientFactory
 *
 * @package Ep\Search
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/core
 */
class ClientFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param array|null $options
     * @return SolariumClient
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null): SolariumClient
    {
        $adapter = new Curl();
        $eventDispatcher = new EventDispatcher();

        $config = $container->get('config')['search'] ?? [];

        return new SolariumClient($adapter, $eventDispatcher, [
            'endpoint' => [
                'default' => $config,
            ],
        ]);
    }
}
