<?php
namespace EpTest;

use Ep\ConfigProvider;
use Psr\Container\ContainerInterface;
use Laminas\ConfigAggregator\ArrayProvider;
use Laminas\ConfigAggregator\ConfigAggregator;
use Laminas\ServiceManager\ServiceManager;

/**
 * Omogućava pristup konfiguriranom containeru.
 *
 * @package EpTest
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-webshop
 */
trait ContainerAwareTrait
{
    /**
     * @param array $config
     *
     * @return ContainerInterface|\Interop\Container\ContainerInterface|ServiceManager
     */
    protected function createContainer(array $config = []): ContainerInterface
    {
        $config = (new ConfigAggregator([
            \Ak\Form\ConfigProvider::class,
            \Mezzio\ConfigProvider::class,
            ConfigProvider::class,
            new ArrayProvider([
                'app' => [
                    'development' => true,
                ],
            ]),
            new ArrayProvider($config),
        ]))->getMergedConfig();

        $container = new ServiceManager($config['dependencies']);
        $container->setService('config', $config);

        return $container;
    }
}
