<?php
declare(strict_types=1);

namespace EpTest\Search;

use EpTest\ContainerAwareTrait;
use PHPUnit\Framework\TestCase;
use Solarium\Client;

/**
 * Class ClientFactoryTest
 *
 * @package EpTest\Search
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/ep-core
 */
final class ClientFactoryTest extends TestCase
{
    use ContainerAwareTrait;

    public function testCanCreateAWorkingClient()
    {
        $container = $this->createContainer([
            'search' => [
                'host' => 'autokreso-baza',
                'core' => 'motostop_hr',
            ],
        ]);

        /** @var Client $client */
        $client = $container->get('search');
        $this->assertInstanceOf(Client::class, $client);

        $ping = $client->createPing();
        $result = $client->ping($ping);

        $this->assertEquals(200, $result->getResponse()->getStatusCode());
    }
}
